<template>
  <v-app class="diagramWard">
    <div class="diagramWard__title">
      <h1>Диаграмма</h1>
    </div>
    <div class="diagramWard__subtitle">
      <h2>Нажмите для получения диаграммы</h2>
    </div>

    <v-dialog v-model="dialog" max-width="500px">
      <template v-slot:activator="{ on, attrs }">
        <v-btn class="diagramWard__btn" v-bind="attrs" v-on="on" style="margin-right: auto">Создать</v-btn>
      </template>
      <v-card>
        <v-card-title>
          <span class="text-h5">{{ "Получить диаграмму" }}</span>
        </v-card-title>

        <v-card-text>
          <v-container>
            <v-row>
              <v-col cols="12" sm="6" md="12">
                <v-text-field v-model="chartData" item-value="year" label="Дата" placeholder="YYYY-MM-DD"></v-text-field>
              </v-col>
            </v-row>
          </v-container>
        </v-card-text>

        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="#AFFFCF" @click="close">Закрыть</v-btn>
          <v-btn color="#AFFFCF" @click="requestReport">Получить диаграмму</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>

    <GChart v-if="this.checker"
        type="ColumnChart"
        :data="chartData"
        :options="chartOptions"
            class="diagramWard__diagram"
    />
  </v-app>
</template>

<script>
import { GChart } from 'vue-google-charts'
import axios from "axios";

export default {
  name: "WardDiagram",
  components: {
    // eslint-disable-next-line vue/no-unused-components
    GChart
  },
  data() {
    return {
      chartData: [],
      checker: false,
      dialog: false,
      chartOptions: {
        chart: {
          title: 'Company Performance',
          subtitle: 'Sales, Expenses, and Profit: 2014-2017',
        }
      }
    }
  },

  methods: {
    async fetchDiagram(date) {
      axios
          .get(this.$root.globalVar + '/diagram/doctor/' + date)
          .then(response => {
            const header = [['Палата', 'Температура']]
            const data = Object.entries(response.data.diagramData)
            this.chartData = header.concat(data)
          })
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: сервер отключен.')
          })
    },

    close() {
      this.dialog = false
    },

    requestReport() {
      this.fetchDiagram(this.chartData)
      this.checker = true
      this.dialog = false
    }
  }
}
</script>

<style lang="scss" scoped>
.diagramWard {
  &__title {
    margin: 60px 0 30px 0;
    text-align: center;
  }

  &__subtitle {
    margin: 0 0 20px 50px;
  }

  &__btn {
    margin: 0 0 50px 50px;
  }

  &__diagram {
    width: 80%;
    margin: 0 auto;
  }
}
</style>